/*This gives about 829 revs/day*/
const int HallPin = A0; //Identify those things that will not change
const int CWpin = 12;
const int CCWpin = 13;
const int LED11 = 11;
const int LED10 = 10;
const int LED9 = 9;
const int LED8 = 8;
const int LED7 = 7;
const int LED6 = 6;
const int LED5 = 5;
const int LED4 = 4;
int autoDelay = 1000;
int timer = 500;
int timer2 = 3000;
int repeats = 10;
int previous;
int HallValue = 1; //Response from the Hall effect sensor
int time = 0;
int state;
int count = 0;
int q = 0;
int i;
int j;
int ledPins[] = {
  11, 4, 7, 6, 8, 10, 5, 9,
};
int pinCount = 8;
void blinkIt() {
  //Initiate rapid blink sequence
  for (int thisPin = 0; thisPin < pinCount; thisPin++) {
    //Turn the pin on:
    digitalWrite(ledPins[thisPin], HIGH);
    delay(timer2);
    //Turn the pin off:
    digitalWrite(ledPins[thisPin], LOW);
    delay(timer2);
  }
  //Loop from the highest pin to the lowest:
  for (int thisPin = pinCount - 1; thisPin >= 0; thisPin--) {
    //Turn the pin on:
    digitalWrite(ledPins[thisPin], HIGH);
    delay(timer2);
    //Turn the pin off:
    digitalWrite(ledPins[thisPin], LOW);
    delay(timer2);
  }
}
void flashIt() {
  //Initiate rapid blink sequence
  for (int thisPin = 0; thisPin < pinCount; thisPin++) {
    //Turn the pin on:
    digitalWrite(ledPins[thisPin], HIGH);
    delay(timer2);
    //Turn the pin off:
    digitalWrite(ledPins[thisPin], LOW);
  }
  //Loop from the highest pin to the lowest:
  for (int thisPin = pinCount - 1; thisPin >= 0; thisPin--) {
    //Turn the pin on:
    digitalWrite(ledPins[thisPin], HIGH);
    delay(timer2);
    //Turn the pin off:
    digitalWrite(ledPins[thisPin], LOW);
  }
}
void allatOncefast() {
  {
    digitalWrite(LED4, HIGH);
    digitalWrite(LED5, HIGH);
    digitalWrite(LED6, HIGH);
    digitalWrite(LED7, HIGH);
    digitalWrite(LED8, HIGH);
    digitalWrite(LED9, HIGH);
    digitalWrite(LED10, HIGH);
    digitalWrite(LED11, HIGH);
    delay(500);
    digitalWrite(LED4, LOW);
    digitalWrite(LED5, LOW);
    digitalWrite(LED6, LOW);
    digitalWrite(LED7, LOW);
    digitalWrite(LED8, LOW);
    digitalWrite(LED9, LOW);
    digitalWrite(LED10, LOW);
    digitalWrite(LED11, LOW);
    delay(500);
  }
}
void allatOnce() {
  {
    digitalWrite(LED4, HIGH);
    digitalWrite(LED5, HIGH);
    digitalWrite(LED6, HIGH);
    digitalWrite(LED7, HIGH);
    digitalWrite(LED8, HIGH);
    digitalWrite(LED9, HIGH);
    digitalWrite(LED10, HIGH);
    digitalWrite(LED11, HIGH);
    delay(4000);
    digitalWrite(LED4, LOW);
    digitalWrite(LED5, LOW);
    digitalWrite(LED6, LOW);
    digitalWrite(LED7, LOW);
    digitalWrite(LED8, LOW);
    digitalWrite(LED9, LOW);
    digitalWrite(LED10, LOW);
    digitalWrite(LED11, LOW);
    delay(2000);
  }
}
void setup() {
  pinMode(HallPin, INPUT); //Identifies inputs and outputs
  pinMode(CWpin, OUTPUT);
  pinMode(CCWpin, OUTPUT);
  Serial.begin(9600);
  for (int thisPin = 0; thisPin < pinCount; thisPin++) {
    pinMode(ledPins [thisPin], OUTPUT);
  }
}
void loop() {
  int HallValue = (digitalRead(HallPin)); //Sets value of initial Hall effect
  if (HallValue == HIGH && previous == LOW) {
    if (state == HIGH)
      state = LOW;
    else
      state = HIGH;
    //Increments counter each time the Hall effect sensor passes the magnet
    count++;
  }
  /* The "Serial.print" line was used in development. I left it in so that
    you can experiment and look at some of the values on a serial
    monitor. You might even want to change the parameters of what you
    are looking at in the monitor.
  */
  Serial.print("HallValue ");
  Serial.println(HallValue);
  Serial.print("count ");
  Serial.println(count);
  Serial.print("CCW ");
  Serial.println(" ");
  if (count == 1) {
    digitalWrite(CCWpin, HIGH);
    digitalWrite(CWpin, LOW);
  }
  if (count == 3) {
    digitalWrite(CWpin, HIGH);
    digitalWrite(CCWpin, HIGH);
  }
  if (count == 3) {
    for (i = 0; i < repeats; i++) {
      allatOncefast();
    }
    count = count + 1;
  }
  if (count == 3) {
    digitalWrite(CWpin, LOW);
    digitalWrite(CCWpin, HIGH);
  }
  if (count == 4) {
    digitalWrite(CWpin, HIGH);
    digitalWrite(CCWpin, HIGH);
  }
  if (count == 4) {
    for (q = 0; q < repeats; q++) {
      blinkIt();
    }
    count = count + 1;
  }
  if (count == 5) {
    for (j = 0; j < repeats; j++) {
      allatOnce();
    }
    delay(50);
    count = count + 1;
  }
  if (count == 6) {
    digitalWrite(CCWpin, LOW);
    digitalWrite(CWpin, HIGH);
  }
  if (count == 7) {
    digitalWrite(CWpin, LOW);
    digitalWrite(CCWpin, LOW);
  }
  if (count == 7) {
    for (i = 0; i < repeats; i++) {
      flashIt();
    }
    count = count + 1;
  }
  if (count == 8) {
    digitalWrite(CCWpin, HIGH);
    digitalWrite(CWpin, LOW);
  }
  if (count == 10) {
    for (i = 0; i < repeats; i++) {
      allatOncefast();
    }
    count = count + 1;
  }
  if (count == 11) {
    digitalWrite(CCWpin, LOW);
    digitalWrite(CWpin, LOW);
  }
  if (count == 11) {
    for (i = 0; i < repeats; i++) {
      blinkIt();
    }
    delay(2000);
    count = count + 1;
  }
  if (count == 12) {
    digitalWrite(CCWpin, LOW);
    digitalWrite(CWpin, HIGH);
  }
  if (count == 13) {
    digitalWrite(CCWpin, HIGH);
    digitalWrite(CWpin, HIGH);
  }
  if (count == 13) {
    for (i = 0; i < repeats; i++) {
      flashIt();
    }
    count = count + 1;
  }
  if (count == 14) {
    for (i = 0; i < repeats; i++) {
      allatOnce();
    }
  }
  if (count == 14) {
    digitalWrite(CWpin, LOW);
    digitalWrite(CCWpin, HIGH);
    delay(autoDelay);
  }
  if (count == 17) {
    digitalWrite(CWpin, HIGH);
    digitalWrite(CCWpin, HIGH);
  }
  if (count == 17) {
    for (i = 0; i < 20; i++) {
      blinkIt();
    }
  }
  {
    for (i = 0; i < repeats; i++) {
      allatOncefast();
    }
    count = count + 1;
  }
  if (count == 18) {
    digitalWrite(CCWpin, HIGH);
    digitalWrite(CWpin, LOW);
    delay(2000);
    digitalWrite(CCWpin, LOW);
    digitalWrite(CWpin, HIGH);
    delay(2000);
  }
  if (count > 20) {
    count = 0;
  }
  previous = HallValue;
}
